---
title: URL
slug: Web/API/URL
tags:
  - API
  - Address
  - Domain
  - Interface
  - Location
  - Networking
  - Reference
  - URI
  - URL
  - URL API
  - Web
  - hostname
  - href
  - origin
---
<p>{{APIRef("URL API")}}</p>

<p><span class="seoSummary">The <strong><code>URL</code></strong> interface is used to parse, construct, normalize, and encode {{glossary("URL", "URLs")}}. It works by providing properties which allow you to easily read and modify the components of a URL.</span> You normally create a new <code>URL</code> object by specifying the URL as a string when calling its constructor, or by providing a relative URL and a base URL. You can then easily read the parsed components of the URL or make changes to the URL.</p>

<p>If a browser doesn't yet support the {{domxref("URL.URL", "URL()")}} constructor, you can access a URL object using the {{domxref("Window")}} interface's {{domxref("Window.URL")}} property. Be sure to check to see if any of your target browsers require this to be prefixed.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("URL.URL", "new URL()")}}</dt>
 <dd>Creates and returns a <code>URL</code> object referencing the URL specified using an absolute URL string, or a relative URL string and a base URL string.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("URL.hash", "hash")}}</dt>
 <dd>A {{domxref("USVString")}} containing a <code>'#'</code> followed by the fragment identifier of the URL.</dd>
 <dt>{{domxref("URL.host", "host")}}</dt>
 <dd>A {{domxref("USVString")}} containing the domain (that is the <em>hostname</em>) followed by (if a port was specified) a <code>':'</code> and the <em>port</em> of the URL.</dd>
 <dt>{{domxref("URL.hostname", "hostname")}}</dt>
 <dd>A {{domxref("USVString")}} containing the domain of the URL.</dd>
 <dt>{{domxref("URL.href", "href")}}</dt>
 <dd>A stringifier that returns a {{domxref("USVString")}} containing the whole URL.</dd>
 <dt>{{domxref("URL.origin", "origin")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("USVString")}} containing the origin of the URL, that is its scheme, its domain and its port.</dd>
 <dt>{{domxref("URL.password", "password")}}</dt>
 <dd>A {{domxref("USVString")}} containing the password specified before the domain name.</dd>
 <dt>{{domxref("URL.pathname", "pathname")}}</dt>
 <dd>Is a {{domxref("USVString")}} containing an initial <code>'/'</code> followed by the path of the URL, not including the query string or fragment.</dd>
 <dt>{{domxref("URL.port", "port")}}</dt>
 <dd>A {{domxref("USVString")}} containing the port number of the URL.</dd>
 <dt>{{domxref("URL.protocol", "protocol")}}</dt>
 <dd>A {{domxref("USVString")}} containing the protocol scheme of the URL, including the final <code>':'</code>.</dd>
 <dt>{{domxref("URL.search", "search")}}</dt>
 <dd>A {{domxref("USVString")}} indicating the URL's parameter string; if any parameters are provided, this string includes all of them, beginning with the leading <code>?</code> character.</dd>
 <dt>{{domxref("URL.searchParams", "searchParams")}} {{readonlyInline}}</dt>
 <dd>A {{domxref("URLSearchParams")}} object which can be used to access the individual query parameters found in <code>search</code>.</dd>
 <dt>{{domxref("URL.username","username")}}</dt>
 <dd>A {{domxref("USVString")}} containing the username specified before the domain name.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("URL.toString", "toString()")}}</dt>
 <dd>Returns a {{domxref("USVString")}} containing the whole URL. It is a synonym for {{domxref("URL.href")}}, though it can't be used to modify the value.</dd>
 <dt>{{domxref("URL.toJSON", "toJSON()")}}</dt>
 <dd>Returns a {{domxref("USVString")}} containing the whole URL. It returns the same string as the <code>href</code> property.</dd>
</dl>

<h2 id="Static_methods">Static methods</h2>

<dl>
 <dt>{{domxref("URL.createObjectURL", "createObjectURL()")}}</dt>
 <dd>Returns a {{domxref("DOMString")}} containing a unique blob URL, that is a URL with <code>blob:</code> as its scheme, followed by an opaque string uniquely identifying the object in the browser.</dd>
 <dt>{{domxref("URL.revokeObjectURL", "revokeObjectURL()")}}</dt>
 <dd>Revokes an object URL previously created using {{domxref("URL.createObjectURL()")}}.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>The constructor takes a <code>url</code> parameter, and an optional <code>base</code> parameter to use as a base if the <code>url</code> parameter is a relative URL:</p>

<pre class="brush: js notranslate">const url = new URL('../cats', 'http://www.example.com/dogs');
console.log(url.hostname); // "www.example.com"
console.log(url.pathname); // "/cats"
</pre>

<p>URL properties can be set to construct the URL:</p>

<pre class="brush: js notranslate">url.hash = 'tabby';
console.log(url.href); // "http://www.example.com/cats#tabby"
</pre>

<p>URLs are encoded according to the rules found in {{RFC(3986)}}. For instance:</p>

<pre class="brush: js notranslate">url.pathname = 'démonstration.html';
console.log(url.href); // "http://www.example.com/d%C3%A9monstration.html"
</pre>

<p>The {{domxref("URLSearchParams")}} interface can be used to build and manipulate the URL query string.</p>

<p>To get the search params from the current window's URL, you can do this:</p>

<pre class="brush: js notranslate">// https://some.site/?id=123
const parsedUrl = new URL(window.location.href);
console.log(parsedUrl.searchParams.get("id")); // "123"
</pre>

<p>The {{domxref("URL.toString", "toString()")}} method of <code>URL</code> just returns the value of the {{domxref("URL.href", "href")}} property, so the constructor can be used to normalize and encode a URL directly.</p>

<pre class="brush: js notranslate">const response = await fetch(new URL('http://www.example.com/démonstration.html'));</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('File API', '#creating-revoking', 'URL')}}</td>
   <td>{{Spec2('File API')}}</td>
   <td>Added the static methods <code>URL.createObjectURL()</code> and <code>URL.revokeObjectURL</code><code>()</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('URL', '#api', 'API')}}</td>
   <td>{{Spec2('URL')}}</td>
   <td>Initial definition (implements <code>URLUtils</code>).</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.URL")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/URL_API">URL API</a></li>
 <li><a href="/en-US/docs/Learn/Common_questions/What_is_a_URL">What is a URL?</a></li>
 <li>Property to obtain a <code>URL</code> object: {{domxref("Window.URL")}}.</li>
 <li>{{domxref("URLSearchParams")}}.</li>
</ul>
